#include <bits/stdc++.h>

using namespace std;

struct Student{
    Student(int first, int second, int score) : first(first), second(second), score(score), school(-1){}
    Student(): first(0), second(0), score(0), school(-1){}
    int first;
    int second;
    int score;
    int school;
    bool operator<(const Student & stud) const{
        return score < stud.score;
    }
};

int main() {
    while (true){
        int N,M,C;
        cin >> N;
        if(cin.eof())
            break;
        cin >> M;
        cin >> C;
        std::vector<Student> students(N,{0,0,0});
        std::vector<set<Student>> schools(M,set<Student>());
        for (int i = 0; i < N; ++i) {
            int first,second;
            cin >> first;
            cin >> second;

            students[i] = Student(first,second,i);
        }
        bool valid = true;
        while(valid){
            valid = false;
            for (int i = 0; i < M; ++i) {
                for (int j = N-1; j >= 0; --j) {
                    Student dummy(1,1,N+1);
                    Student &currentStudend = students[j];
                    auto iter = schools[i].lower_bound(dummy);
                    if(schools[i].size() < C){
                        schools[i].insert(currentStudend);
                        currentStudend.school = i;
                        valid = true;
                    }
                        //first line after or
                    else if( currentStudend < *iter ){
                        if(schools[i].size() == C ){
                            schools[i].erase(iter);
                            currentStudend.school = -1;
                            valid = true;
                            continue;
                        }
                        schools[i].insert(currentStudend);
                        currentStudend.school = i;
                        valid = true;
                    }
                    else if(currentStudend.first == i || currentStudend.second == i){
                        if(schools[i].size() == C ){
                            schools[i].erase(iter);
                            currentStudend.school = -1;
                            valid = true;
                            continue;
                        }
                        schools[i].insert(currentStudend);
                        currentStudend.school = i;
                        valid = true;
                    }
                    else if(currentStudend.school == -1 || currentStudend.school == currentStudend.second){
                        if(schools[i].size() == C ){
                            schools[i].erase(iter);
                            currentStudend.school = -1;
                            valid = true;
                            continue;
                        }
                        schools[i].insert(currentStudend);
                        currentStudend.school = i;
                        valid = true;
                    }
                }
            }
        }
        int first = 0;
        int second = 0;
        for (int i = 0; i < N; ++i) {
            Student & currentStudent = students[i];
            if(currentStudent.school == currentStudent.first){
                first += 1;
            }
            if(currentStudent.school == currentStudent.second){
                second += 1;
            }
        }
        cout << first << second << endl;
    }


    return 0;
}